Index: trunk/VUT/Ogre/resources/VisibilityDemo.overlay
===================================================================
--- trunk/VUT/Ogre/resources/VisibilityDemo.overlay	(revision 159)
+++ trunk/VUT/Ogre/resources/VisibilityDemo.overlay	(revision 160)
@@ -12,5 +12,5 @@
 }
 
-Example/Visibility/DemoOverlay
+Example/Visibility/CullStatsOverlay
 {
 	zorder 500
@@ -40,5 +40,4 @@
 		{
 			left 5
-			top 5
 			width 180
 			caption [SPACE] Algorithm
@@ -47,5 +46,4 @@
 		{
 			left 210
-			top 5
 			width 120
 			height 30
@@ -56,5 +54,4 @@
 		{
 			left 5
-			top 20
 			width 120
 			height 30
@@ -64,5 +61,4 @@
 		{
 			left 210
-			top 20
 			width 120
 			height 30
@@ -72,5 +68,4 @@
 		{
 			left 5
-			top 35
 			width 120
 			height 30
@@ -80,5 +75,4 @@
 		{
 			left 210
-			top 35
 			width 120
 			height 30
@@ -88,5 +82,4 @@
 		{
 			left 5
-			top 50
 			width 120
 			height 30
@@ -96,5 +89,4 @@
 		{
 			left 210
-			top 50
 			width 120
 			height 30
@@ -104,5 +96,4 @@
 		{
 			left 5
-			top 65
 			width 120
 			height 30
@@ -113,9 +104,22 @@
 		{
 			left 210
-			top 65
-			width 120
-			height 30
-			caption :
-		}
+			width 120
+			height 30
+			caption :
+		}
+		element TextArea(Example/Visibility/CurrentObjectType): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 120
+			height 30
+			caption [F7] Object type
+		}	
+		element TextArea(Example/Visibility/CurrentObjectTypeInfo): Example/Visibility/Templates/BasicText
+		{
+			left 210
+			width 90
+			font_name TrebuchetMSBold
+			caption :			
+		}	
 	}
 
@@ -128,5 +132,5 @@
 		top 5
 		width 320
-		height 150
+		height 135
 		material Core/StatsBlockCenter
         	border_size 1 1 1 1
@@ -144,5 +148,4 @@
 		{
 			left 5
-			top 5
 			width 180
 			height 30
@@ -152,5 +155,4 @@
 		{
 			left 180
-			top 5
 			width 90
 			height 30
@@ -160,5 +162,4 @@
 		{
 			left 5
-			top 20
 			width 180
 			height 30
@@ -168,5 +169,4 @@
 		{
 			left 180
-			top 20
 			width 90
 			height 30
@@ -176,5 +176,4 @@
 		{
 			left 5
-			top 35
 			width 180
 			height 30
@@ -184,5 +183,4 @@
 		{
 			left 180
-			top 35
 			width 90
 			height 30
@@ -192,5 +190,4 @@
 		{
 			left 5
-			top 50
 			width 180
 			height 30
@@ -200,5 +197,4 @@
 		{
 			left 180
-			top 50
 			width 90
 			height 30
@@ -208,5 +204,4 @@
 		{
 			left 5
-			top 65
 			width 180
 			height 30
@@ -216,21 +211,18 @@
 		{
 			left 180
-			top 65
-			width 90
-			height 30
-			caption :
-		}
-		element TextArea(Example/Visibility/Objects): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 80
+			width 90
+			height 30
+			caption :
+		}
+		element TextArea(Example/Visibility/ObjectsCount): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption Number of objects
 		}	
-		element TextArea(Example/Visibility/ObjectsInfo): Example/Visibility/Templates/BasicText
-		{
-			left 180
-			top 80
+		element TextArea(Example/Visibility/ObjectsCountInfo): Example/Visibility/Templates/BasicText
+		{
+			left 180
 			width 90
 			height 30
@@ -240,5 +232,4 @@
 		{
 			left 5
-			top 95
 			width 180
 			height 30
@@ -248,41 +239,9 @@
 		{
 			left 180
-			top 95
 			width 90
 			font_name TrebuchetMSBold
 			caption :			
-		}		
-		element TextArea(Example/Visibility/DelayedQueriesIssued): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 110
-			width 180
-			height 30
-			caption Avg. queries issued 
-		}	
-		element TextArea(Example/Visibility/DelayedQueriesIssuedInfo): Example/Visibility/Templates/BasicText
-		{
-			left 180
-			top 110
-			width 90
-			font_name TrebuchetMSBold
-			caption :			
-		}		
-		element TextArea(Example/Visibility/DelayedTraversedNodes): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 125
-			width 180
-			height 30
-			caption Avg. traversed Nodes
-		}	
-		element TextArea(Example/Visibility/DelayedTraversedNodesInfo): Example/Visibility/Templates/BasicText
-		{
-			left 180
-			top 125
-			width 90
-			font_name TrebuchetMSBold
-			caption :			
-		}			
+		}
+		
 	}
 }
@@ -334,137 +293,178 @@
 			font_name TrebuchetMSBold
 			char_height 19
-			caption Additional Options
+			caption Help: Additional Options
 			colour_top 1 1 0.7
 			colour_bottom 1 1 0.7
 		}
 
-		element TextArea(Example/Visibility/Help/ShowHelpInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 30
+		element TextArea(Example/Visibility/Help/ShowHelp): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [F1] Show / Hide this screen
 		}
-		element TextArea(Example/Visibility/Help/StatsInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 45
+		element TextArea(Example/Visibility/Help/Stats): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [F2] Show / Hide stats
 		}
-		element TextArea(Example/Visibility/Help/AppStateInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 75
+		element TextArea(Example/Visibility/Help/AppState): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [F3] Toggle between interactive / recorded walkthrough
 		}
-		element TextArea(Example/Visibility/Help/RecordedInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 60
+		element TextArea(Example/Visibility/Help/Recorded): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [F4] Start / End frame recording
 		}
-		element TextArea(Example/Visibility/Help/ScreenshotsInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 105
+		element TextArea(Example/Visibility/Help/Screenshots): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [F11] Screenshot
 		}
-		element TextArea(Example/Visibility/Help/WriteOutInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 120
-			width 180
-			height 30
-			caption [F12] Write screen objects to file
-		}
+		element TextArea(Example/Visibility/Help/WriteOut): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 180
+			height 30
+			caption [F12] Write scene entities to file
+		}
+		
 		//-- visualization
-		element TextArea(Example/Visibility/Help/VizInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 150
+		element TextArea(Example/Visibility/Help/VizSection): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 180
+			height 30
+			caption ****** Visualization ******
+		}
+		element TextArea(Example/Visibility/Help/Viz): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [1] Show / hide visualization
 		}
-		element TextArea(Example/Visibility/Help/NextVizModeInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 165
+		element TextArea(Example/Visibility/Help/NextVizMode): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 175
 			height 30
 			caption [2] Toggle visualization mode
 		}
-		element TextArea(Example/Visibility/Help/ZoomVizInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 180
+		element TextArea(Example/Visibility/Help/ZoomViz): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 190
 			height 30
 			caption [3][4] Zoom in / out of visualization
 		}
-		element TextArea(Example/Visibility/Help/SceneDetailInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 210
+		element TextArea(Example/Visibility/Help/SceneDetail): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [R] Toggle between solid / wireframe / point based rendering
 		}
-		element TextArea(Example/Visibility/Help/DisplayCameraDetailsInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 225
+		element TextArea(Example/Visibility/Help/DisplayCameraDetails): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [P] Show / hide camera details 
 		}
-		element TextArea(Example/Visibility/Help/DisplayOctreeInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 240
+		element TextArea(Example/Visibility/Help/DisplayOctree): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [T] Show / hide octree 
 		}
-		element TextArea(Example/Visibility/Help/UseShadowsInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 255
+		element TextArea(Example/Visibility/Help/UseShadows): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [S] Show / hide shadows
 		}
-		element TextArea(Example/Visibility/Help/FilterInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 270
+		element TextArea(Example/Visibility/Help/Filter): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [F] toggle filtering method (trilinear, anisotropic, bilinear)
 		}
-		element TextArea(Example/Visibility/Help/FromCameraQueryInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 285
+		element TextArea(Example/Visibility/Help/VisQuery): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 180
+			height 30
+			caption ****** Visibility Queries ******
+		}
+		element TextArea(Example/Visibility/Help/FromCameraQuery): Example/Visibility/Templates/BasicText
+		{
+			left 5
 			width 180
 			height 30
 			caption [F5] From camera visible pixels (+ SHIFT: relative visibility)
 		}
-		element TextArea(Example/Visibility/Help/FromPointQueryInfo): Example/Visibility/Templates/BasicText
-		{
-			left 5
-			top 60
-			width 300
+		element TextArea(Example/Visibility/Help/FromPointQuery): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 180
 			height 30
 			caption [F6] From camera visible pixels (+ SHIFT: relative visibility)
+		}
+		element TextArea(Example/Visibility/Help/QueryType): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 180
+			height 30
+			caption [I] Change between occlusion query / item buffer visibility query
+		}
+		element TextArea(Example/Visibility/Help/QueryTarget): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 180
+			height 30
+			caption [C] Mesh / Patch visibility (only item buffer)
+		}
+		element TextArea(Example/Visibility/Help/SceneObjects): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 180
+			height 30
+			caption ******* Generation / Destruction of scene objects ******
+		}
+		element TextArea(Example/Visibility/Help/GenerateObjects): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 180
+			height 30
+			caption [F8] Generate 500 objects
+		}
+		element TextArea(Example/Visibility/Help/RemoveObjects): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 180
+			height 30
+			caption [DEL] Remove generated objects 
+		}
+		element TextArea(Example/Visibility/Help/DropObject): Example/Visibility/Templates/BasicText
+		{
+			left 5
+			width 180
+			height 30
+			caption [MOUSE LEFT] Drop object on terrain
 		}
 	}
@@ -524,5 +524,4 @@
 		{
 			left 5
-			top 30
 			width 90
 			height 30
@@ -534,5 +533,4 @@
 		{
 			left 180
-			top 30
 			width 90
 			height 30
@@ -543,5 +541,4 @@
 		{
 			left 5
-			top 45
 			width 90
 			height 30
@@ -551,5 +548,4 @@
 		{
 			left 180
-			top 45
 			width 90
 			height 30
@@ -560,5 +556,4 @@
 		{
 			left 5
-			top 60
 			width 90
 			height 30
@@ -568,5 +563,4 @@
 		{
 			left 180
-			top 60
 			width 90
 			height 30
@@ -578,13 +572,11 @@
 		{
 			left 5
-			top 75
 			width 90
 			height 30
 			caption Visible patches
 		}
-		element TextArea(Example/Visibility/Query/VisiblePatchInfo): Example/Visibility/Templates/BasicText
-		{
-			left 180
-			top 75
+		element TextArea(Example/Visibility/Query/VisiblePatchesInfo): Example/Visibility/Templates/BasicText
+		{
+			left 180
 			width 90
 			height 30
@@ -595,5 +587,4 @@
 		{
 			left 5
-			top 90
 			width 90
 			height 30
@@ -604,5 +595,4 @@
 		{
 			left 180
-			top 90
 			width 90
 			height 30
@@ -613,5 +603,4 @@
 		{
 			left 5
-			top 105
 			width 90
 			height 30
@@ -622,5 +611,4 @@
 		{
 			left 180
-			top 105
 			width 90
 			height 30
@@ -630,5 +618,4 @@
 		{
 			left 5
-			top 120
 			width 90
 			height 30
@@ -639,5 +626,4 @@
 		{
 			left 180
-			top 120
 			width 90
 			height 30